#********************************************************************************
# wrapper around the origin emerge from portage (part of qrtools)               *
#                                                                               *
# Author: Kai Peter (4sh) (kp@aldox.org), ©2007, ©2017-                         *
#                                                                               *
# Version: 0.17                                                                 *
# License: ISC license                                                          *
#********************************************************************************

function error () {

  MSG="Unknown error!"
  echo "$MSG" && exit 1
}


declare ALLOPTS="$@" 	    # first save _ALL_ options given at the command line
declare EPARMS=""           # options used by gentoo's 'emerge'

#********************************************************************************
# check for 'qrtmerge' options:
# --qrtclean   - run qrtclean after emerge
# --qsystem    - rebuild the toolchain


# check if option '--qrtclean' is given and set flag if true
echo "$ALLOPTS" | grep '\-\-qrtclean' 2>&1>/dev/null && fQRTCLEAN=1
echo "$ALLOPTS" | grep '\-\-qsystem'  2>&1>/dev/null && fQSYSTEM=1
# 
# remove qrtmerge specific options
EPARMS=${ALLOPTS}
EPARMS=$(sed 's/\-\-qrtclean/''/g' <<< $EPARMS)
EPARMS=$(sed 's/\-\-qsystem/''/g'  <<< $EPARMS)

# ... and if yes, activate the related action
#[ "$EC" = "0" ] && QRTCLEAN=1
echo 1: $fQRTCLEAN
echo 2: $EPARMS
exit

# Remove the extra option from input (if not given, sed does nothing). Afterwards
# '$EPARMS' should contain valid options for portage's emerge only.
#EPARMS=$(sed 's/\-\-qrtclean/''/g' <<< $PARAMS)
#echo EP: $EPARMS

# now run the original emerge (DON'T QUOTE '${EPARMS}' HERE!)
[ "$EPARMS" ] && emerge ${EPARMS} #|| error 1
EC=$?

#if [ "$EC" = " 0" ] && [ "$QRTCLEAN" = "1" ] ; then
#  qrtclean
#fi
[ "$EC" = " 0" ] && [ "$QRTCLEAN" = "1" ] && qrtclean

#echo PATH: "$PATH"
