#********************************************************************
# simple wrapper to check all php modules using eselect


showHelp() {
  printf "Usage: $(basename $0) [ N ] [ -h ]\n\n"
  printf "\t-h\t- show this usage info\n"
  printf "\tN \t- an integer to select version\n"
  exit 0
}
doList() {
  echo -e '\033[93m'$M:'\033[0m'
  eselect php list "$M"
}
doSet() {
#echo "set"
  eselect php set $1 $N 2>/dev/null
  EC=$?
# echo EC: $EC
  return "$EC"
}

# Start processing
[ "$1" ] && [ "$1" == "-h" ] && showHelp

# check if multiple php versions exists (module cli exists always)
eselect php list cli 2>/dev/null | grep \['0-9'\] >/dev/null && EC=$?
[ "$EC" != "0" ] && echo "Error: couldn't determine php installation!" && exit 1

# integer values are required for comparison
[ "$1" ] && declare -i N="$1" 2>/dev/null
#[ $? -ne 0 ] && echo invalid option && exit 1   # last check of invalid args

if [ "$N" ] ; then
  # argument have to be a number graeter than 1
  [ $N -lt 1 ] && echo "invalid argument" && exit 1
  # check highest available number
  declare -i V=`eselect php list cli | wc -l`
  # argument does not have to be greater then available selections
  [ $N -gt $V ] && echo "invalid selection" && exit 1
fi

#
for M in $(eselect php list-modules)
do
  # Execute doSet OR doList, check exit code of doSet
  # don't execute doList after doSet returns an error
  [ "$N" ] && doSet "$M" || ( [ "$EC" == 0 ] && doList )
done
